// Code generated by counterfeiter. DO NOT EDIT.
package loggerfakes

import (
	"sync"

	"gitlab.com/hackandsla.sh/letterbox/internal/logger"
)

type FakeLogger struct {
	DebugwStub        func(string, ...logger.Fields)
	debugwMutex       sync.RWMutex
	debugwArgsForCall []struct {
		arg1 string
		arg2 []logger.Fields
	}
	ErrorwStub        func(string, error, ...logger.Fields)
	errorwMutex       sync.RWMutex
	errorwArgsForCall []struct {
		arg1 string
		arg2 error
		arg3 []logger.Fields
	}
	InfoErrStub        func(string, error, ...logger.Fields)
	infoErrMutex       sync.RWMutex
	infoErrArgsForCall []struct {
		arg1 string
		arg2 error
		arg3 []logger.Fields
	}
	InfowStub        func(string, ...logger.Fields)
	infowMutex       sync.RWMutex
	infowArgsForCall []struct {
		arg1 string
		arg2 []logger.Fields
	}
	WithStub        func(logger.Fields) logger.Logger
	withMutex       sync.RWMutex
	withArgsForCall []struct {
		arg1 logger.Fields
	}
	withReturns struct {
		result1 logger.Logger
	}
	withReturnsOnCall map[int]struct {
		result1 logger.Logger
	}
	invocations      map[string][][]interface{}
	invocationsMutex sync.RWMutex
}

func (fake *FakeLogger) Debugw(arg1 string, arg2 ...logger.Fields) {
	fake.debugwMutex.Lock()
	fake.debugwArgsForCall = append(fake.debugwArgsForCall, struct {
		arg1 string
		arg2 []logger.Fields
	}{arg1, arg2})
	stub := fake.DebugwStub
	fake.recordInvocation("Debugw", []interface{}{arg1, arg2})
	fake.debugwMutex.Unlock()
	if stub != nil {
		fake.DebugwStub(arg1, arg2...)
	}
}

func (fake *FakeLogger) DebugwCallCount() int {
	fake.debugwMutex.RLock()
	defer fake.debugwMutex.RUnlock()
	return len(fake.debugwArgsForCall)
}

func (fake *FakeLogger) DebugwCalls(stub func(string, ...logger.Fields)) {
	fake.debugwMutex.Lock()
	defer fake.debugwMutex.Unlock()
	fake.DebugwStub = stub
}

func (fake *FakeLogger) DebugwArgsForCall(i int) (string, []logger.Fields) {
	fake.debugwMutex.RLock()
	defer fake.debugwMutex.RUnlock()
	argsForCall := fake.debugwArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeLogger) Errorw(arg1 string, arg2 error, arg3 ...logger.Fields) {
	fake.errorwMutex.Lock()
	fake.errorwArgsForCall = append(fake.errorwArgsForCall, struct {
		arg1 string
		arg2 error
		arg3 []logger.Fields
	}{arg1, arg2, arg3})
	stub := fake.ErrorwStub
	fake.recordInvocation("Errorw", []interface{}{arg1, arg2, arg3})
	fake.errorwMutex.Unlock()
	if stub != nil {
		fake.ErrorwStub(arg1, arg2, arg3...)
	}
}

func (fake *FakeLogger) ErrorwCallCount() int {
	fake.errorwMutex.RLock()
	defer fake.errorwMutex.RUnlock()
	return len(fake.errorwArgsForCall)
}

func (fake *FakeLogger) ErrorwCalls(stub func(string, error, ...logger.Fields)) {
	fake.errorwMutex.Lock()
	defer fake.errorwMutex.Unlock()
	fake.ErrorwStub = stub
}

func (fake *FakeLogger) ErrorwArgsForCall(i int) (string, error, []logger.Fields) {
	fake.errorwMutex.RLock()
	defer fake.errorwMutex.RUnlock()
	argsForCall := fake.errorwArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2, argsForCall.arg3
}

func (fake *FakeLogger) InfoErr(arg1 string, arg2 error, arg3 ...logger.Fields) {
	fake.infoErrMutex.Lock()
	fake.infoErrArgsForCall = append(fake.infoErrArgsForCall, struct {
		arg1 string
		arg2 error
		arg3 []logger.Fields
	}{arg1, arg2, arg3})
	stub := fake.InfoErrStub
	fake.recordInvocation("InfoErr", []interface{}{arg1, arg2, arg3})
	fake.infoErrMutex.Unlock()
	if stub != nil {
		fake.InfoErrStub(arg1, arg2, arg3...)
	}
}

func (fake *FakeLogger) InfoErrCallCount() int {
	fake.infoErrMutex.RLock()
	defer fake.infoErrMutex.RUnlock()
	return len(fake.infoErrArgsForCall)
}

func (fake *FakeLogger) InfoErrCalls(stub func(string, error, ...logger.Fields)) {
	fake.infoErrMutex.Lock()
	defer fake.infoErrMutex.Unlock()
	fake.InfoErrStub = stub
}

func (fake *FakeLogger) InfoErrArgsForCall(i int) (string, error, []logger.Fields) {
	fake.infoErrMutex.RLock()
	defer fake.infoErrMutex.RUnlock()
	argsForCall := fake.infoErrArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2, argsForCall.arg3
}

func (fake *FakeLogger) Infow(arg1 string, arg2 ...logger.Fields) {
	fake.infowMutex.Lock()
	fake.infowArgsForCall = append(fake.infowArgsForCall, struct {
		arg1 string
		arg2 []logger.Fields
	}{arg1, arg2})
	stub := fake.InfowStub
	fake.recordInvocation("Infow", []interface{}{arg1, arg2})
	fake.infowMutex.Unlock()
	if stub != nil {
		fake.InfowStub(arg1, arg2...)
	}
}

func (fake *FakeLogger) InfowCallCount() int {
	fake.infowMutex.RLock()
	defer fake.infowMutex.RUnlock()
	return len(fake.infowArgsForCall)
}

func (fake *FakeLogger) InfowCalls(stub func(string, ...logger.Fields)) {
	fake.infowMutex.Lock()
	defer fake.infowMutex.Unlock()
	fake.InfowStub = stub
}

func (fake *FakeLogger) InfowArgsForCall(i int) (string, []logger.Fields) {
	fake.infowMutex.RLock()
	defer fake.infowMutex.RUnlock()
	argsForCall := fake.infowArgsForCall[i]
	return argsForCall.arg1, argsForCall.arg2
}

func (fake *FakeLogger) With(arg1 logger.Fields) logger.Logger {
	fake.withMutex.Lock()
	ret, specificReturn := fake.withReturnsOnCall[len(fake.withArgsForCall)]
	fake.withArgsForCall = append(fake.withArgsForCall, struct {
		arg1 logger.Fields
	}{arg1})
	stub := fake.WithStub
	fakeReturns := fake.withReturns
	fake.recordInvocation("With", []interface{}{arg1})
	fake.withMutex.Unlock()
	if stub != nil {
		return stub(arg1)
	}
	if specificReturn {
		return ret.result1
	}
	return fakeReturns.result1
}

func (fake *FakeLogger) WithCallCount() int {
	fake.withMutex.RLock()
	defer fake.withMutex.RUnlock()
	return len(fake.withArgsForCall)
}

func (fake *FakeLogger) WithCalls(stub func(logger.Fields) logger.Logger) {
	fake.withMutex.Lock()
	defer fake.withMutex.Unlock()
	fake.WithStub = stub
}

func (fake *FakeLogger) WithArgsForCall(i int) logger.Fields {
	fake.withMutex.RLock()
	defer fake.withMutex.RUnlock()
	argsForCall := fake.withArgsForCall[i]
	return argsForCall.arg1
}

func (fake *FakeLogger) WithReturns(result1 logger.Logger) {
	fake.withMutex.Lock()
	defer fake.withMutex.Unlock()
	fake.WithStub = nil
	fake.withReturns = struct {
		result1 logger.Logger
	}{result1}
}

func (fake *FakeLogger) WithReturnsOnCall(i int, result1 logger.Logger) {
	fake.withMutex.Lock()
	defer fake.withMutex.Unlock()
	fake.WithStub = nil
	if fake.withReturnsOnCall == nil {
		fake.withReturnsOnCall = make(map[int]struct {
			result1 logger.Logger
		})
	}
	fake.withReturnsOnCall[i] = struct {
		result1 logger.Logger
	}{result1}
}

func (fake *FakeLogger) Invocations() map[string][][]interface{} {
	fake.invocationsMutex.RLock()
	defer fake.invocationsMutex.RUnlock()
	fake.debugwMutex.RLock()
	defer fake.debugwMutex.RUnlock()
	fake.errorwMutex.RLock()
	defer fake.errorwMutex.RUnlock()
	fake.infoErrMutex.RLock()
	defer fake.infoErrMutex.RUnlock()
	fake.infowMutex.RLock()
	defer fake.infowMutex.RUnlock()
	fake.withMutex.RLock()
	defer fake.withMutex.RUnlock()
	copiedInvocations := map[string][][]interface{}{}
	for key, value := range fake.invocations {
		copiedInvocations[key] = value
	}
	return copiedInvocations
}

func (fake *FakeLogger) recordInvocation(key string, args []interface{}) {
	fake.invocationsMutex.Lock()
	defer fake.invocationsMutex.Unlock()
	if fake.invocations == nil {
		fake.invocations = map[string][][]interface{}{}
	}
	if fake.invocations[key] == nil {
		fake.invocations[key] = [][]interface{}{}
	}
	fake.invocations[key] = append(fake.invocations[key], args)
}

var _ logger.Logger = new(FakeLogger)
